//+------------------------------------------------------------------+
//|                                            HedgeGridCubierto.mq4 |
//|                                                    Kunal Mahtani |
//|                                                         Bogle.es |
//+------------------------------------------------------------------+
#property copyright "Kunal Mahtani"
#property link      "Bogle.es"

extern double Lots = 0.1;
extern int tp=10;
extern int sl=200;
extern double gridsize = 0.0010;
extern bool TradeBuys = true;
extern double openprice = 1.3452;
extern double price_error = 0.0001;

double top,bottom;
bool firsttrade = true;

int init()
{
   if (OrdersTotal() > 0) 
   {
      int ticket = LastOpenTicket();
      OrderSelect(ticket,SELECT_BY_TICKET);
      top = OrderOpenPrice();
   }
   return(0);
}

int deinit()
{
   return(0);
}

int start()
{
   Comment(top);
   int ticket;
   int trade_type;
   if (TradeBuys) trade_type = OP_BUY;
   else trade_type = OP_SELL;
   
   if (OrdersTotal() == 0 && firsttrade)
   {
      if (openprice + price_error > Ask &&  openprice - price_error < Ask)
      {
         ticket = abrir_orden_mercado(trade_type,tp,sl);
         OrderSelect(ticket,SELECT_BY_TICKET);
         top = OrderOpenPrice();
         firsttrade = false;
      }
   }
   else
   {
      if (checktrade_alt())
         {
            ticket = abrir_orden_mercado(trade_type,tp,sl);
            OrderSelect(ticket,SELECT_BY_TICKET);
            top = OrderOpenPrice();
         }
   }
   
   
   
   return(0);
}

bool checktrade()
{
   bool trade = true;
   
   for (int i=0;i < OrdersTotal(); i++)
      {
         OrderSelect(i,SELECT_BY_POS);
         if (MathAbs(Ask - OrderOpenPrice()) <= gridsize || MathAbs(OrderOpenPrice() - Ask) <= gridsize)
         {
            trade = false;  
            break;
         }
      }
   return(trade);
}
bool checktrade_alt()
{
   bool trade = true;
   
   for (int i=0;i < OrdersTotal(); i++)
      {
         OrderSelect(i,SELECT_BY_POS);
         if (MathAbs(Ask - top) <= gridsize || MathAbs(top - Ask) <= gridsize)
         {
            trade = false;  
            break;
         }
      }
   return(trade);
}

int abrir_orden_mercado(int tipo, int tp, int sl)
{
   double precio;
   double stop;
   double profit;
   int colorop;
   int tike;
      
   if (tipo == OP_BUY)
   {
      precio = Ask;
      if (sl == 0)
      {
         stop = 0;
      }
      else
      {
         stop = Ask-sl*Point;
      }
      if (tp == 0)
      {
         profit = 0;
      }
      else
      {
         profit = Ask+tp*Point;
      }
      colorop = Green;
   }
   else
   {
      precio = Bid;
      if (sl == 0)
      {
         stop = 0;
      }
      else
      {
         stop = Bid+sl*Point;
      }
      if (tp == 0)
      {
         profit = 0;
      }
      else
      {
         profit = Bid-tp*Point;
      }
      colorop = Red;
   }
   
   tike = OrderSend(Symbol(),tipo,Lots,precio,3,stop,profit,0,1,0,colorop);
   return(tike);
   
}

void cerrar_todo()
{
   for (int i=0;i < OrdersTotal(); i++)
   {
      OrderSelect(i,SELECT_BY_POS);
      OrderClose(OrderTicket(),Lots,Ask,100,0);
   }
}

int LastOpenTicket(){
    int pos;
    datetime lastTime  = 0;
    int      lastTicket = -1; // None open.
    for(pos = OrdersTotal()-1; pos >= 0 ; pos--) if (
        OrderSelect(pos, SELECT_BY_POS)                 // Only my orders w/
    &&  OrderSymbol()       == Symbol()                 // and my pair.
    &&  OrderOpenTime()     >=  lastTime
    &&  OrderTicket()       >   lastTicket
    ){
      lastTime   = OrderOpenTime();
      lastTicket = OrderTicket();
    }
    return(lastTicket);
}